/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#ifndef _MAIN_H
 #define _MAIN_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <avr/eeprom.h>

#include "mmc.h"
#include "interrupt4.h"
#include "fat.h"
#include "rtl8019.h"
#include "tcp.h"
#include "arp.h"
#include "ip.h"
#include "icmp.h"
#include "clock.h"
#include "uart.h"
#include "ftpd.h"
#include "webpage.h"
#include "telnet.h"
#include "jb/dump.h"
#include "webcam/mca25.h"
#include "webcam/servo.h"

extern	 int checksum	(unsigned char * ,unsigned int,unsigned long);
extern	void httpd		(char* buffer,int *bufferlen);
extern	void OWImain	(void);
extern	void OWI_init	(void);

extern unsigned char mymac[];	// MAC-Adresse
extern unsigned char MYIP[];		// IP-Adresse
unsigned char	VA0;				// temp. Variable
unsigned char	VA2;				// LED-Status
unsigned char	VA3;				// Dallas-Ausgabeschalter
unsigned char	VA4;				// Busleitung4
unsigned char	VA5;				// Busleitung5
unsigned char	VA6;				// Busleitung6
unsigned char	VA7;				// Index fr Namensseite
unsigned char	VAi;				// neues Adrebyte 1
unsigned char	VAj;				// neues Adrebyte 2
unsigned char	VAk;				// neues Adrebyte 3
unsigned char	VAl;				// neues Adrebyte 4
unsigned char VAhAA; 				// Variable fr funkport *** GATREN  ***
unsigned char VAhAB; 				// Variable fr funkport
unsigned char VAhAC; 				// Variable fr funkport
unsigned char VAhAD; 				// Variable fr funkport
unsigned char VAhAE; 				// Variable fr funkport
unsigned char VAhBA; 				// Variable fr funkport *** OBERGESCHOSS ***
unsigned char VAhBB; 				// Variable fr funkport
unsigned char VAhBC; 				// Variable fr funkport
unsigned char VAhBD; 				// Variable fr funkport
unsigned char VAhBE; 				// Variable fr funkport
unsigned char VAhCA; 				// Variable fr funkport *** ERDGESCHOSS  ***
unsigned char VAhCB; 				// Variable fr funkport
unsigned char VAhCC; 				// Variable fr funkport
unsigned char VAhCD; 				// Variable fr funkport
unsigned char VAhCE; 				// Variable fr funkport
unsigned char VAhDA; 				// Variable fr funkport *** KELLER ***
unsigned char VAhDB; 				// Variable fr funkport
unsigned char VAhDC; 				// Variable fr funkport
unsigned char VAhDD; 				// Variable fr funkport
unsigned char VAhDE; 				// Variable fr funkport

unsigned char	VAR;				// refresh-Zeit
unsigned char	VAF;				// funlevel
unsigned char	VAP;				// Bildformat
unsigned char Index;				// Index fr HTML-Wiederholungsschleifen
PGM_P Zeiger;						//

unsigned char VAY;				// PA5
unsigned char VAZ;				// PA6
unsigned char VAB;				// Schalter fr Dump



// Leuchtdiodenport festlegen
#define LED_LINES		PORTD	// Port mit der LED
#define LED_LINES_DIR	DDRD	// Richtungsregister (Eingang oder Ausgang)
#define LED_PIN			7		// Pin an dem die LED angeschlossen ist


// Festlegungen fr das one-wire-interface
#define MAX_DEVICES 		17       	// maximale Anzahl der Dallas-Bausteine + 1
#define erlaubteLeitungen	(OWI_PIN_3 | OWI_PIN_4 | OWI_PIN_5) // zulssige Busleitungen
unsigned char BUSES; 				// Busleitungen (evtl. mehrere Bits durch | verknpfen)
unsigned char	DALLAS[MAX_DEVICES][2];	// Platz fr MAX_DEVICES-1 Dallaschips


//Festlegungen zum EEPROM-Inhalt
#define IPoffset	8


//Festlegungen fr die Webcam
#define ETB 0x17			//End of Transmission Block
#define CAM_BUFFER_LEN 512	//buffer for webcam
extern unsigned char webcam_busy_forconn;	////some webcam control stuff:
extern int webcam_buffer_empty;
extern unsigned char webcam_pic_end;
extern unsigned char webcam_tmp;


//MTU Size setzen (min. 500 / max. 1400)
#define MTU_SIZE  700


//Quarz Frequenz in Hz 
//#define SYSCLK	16000000	// Maximale Frequenz fr ATmega 32
#define SYSCLK	14745600	// Maximale Quarzfrequenz fr die Webcam
//#define SYSCLK	14000000	// Maximale Quarzfrequenz fr die Webcam
//#define SYSCLK	11059200	// 1. Alternative Quarzfrequenz fr die Webcam (3/4)
//#define SYSCLK	 7372800	// 2. Alternative Quarzfrequenz fr die Webcam (1/2)
//#define SYSCLK	 3686400	// 3. Alternative Quarzfrequenz fr die Webcam (1/4)


#define F_CPU SYSCLK	// Definition fr Delay-Routinen
#include <avr/delay.h>
#define delay_ms(a) { if(a<15) _delay_ms(a); else for (unsigned int i=0;i<a;i++) _delay_ms(1); }



#if defined (__AVR_ATmega32__)	
	#define Networkcard_INT_Enable()	enable_external_int (1<<INT0);
	#define Networkcard_INT_Set()	MCUCR=0x01;
#endif	

#if defined (__AVR_ATmega103__)
	#define Networkcard_INT_Enable()	enable_external_int (1<<INT4);
	#define Networkcard_INT_Set()	EICR = 0x03;
#endif
	
#if defined (__AVR_ATmega128__)
	#define Networkcard_INT_Enable()	enable_external_int (1<<INT4);
	#define Networkcard_INT_Set()	EICR = 0x03;
#endif

#endif //_MAIN_H






