/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#include "main.h"
#include "uart.h"

//############################################################################
//Routine fr die serielle Ausgabe
int uart_putchar (char c)
//############################################################################
{
#if USE_MCA25_CAM
	if (mca25_uart_disabled == 1)		// Ausgabe gesperrt
	return (0);
#else
	if (c=='\n') uart_putchar('\r');	// Beim Kamerabetrieb kein CR nach LF einfgen!
#endif
	loop_until_bit_is_set(USR, UDRE);	// Warten bis das letzte Zeichen gesendet wurde
	UDR = c;							// Ausgabe des aktuellen Zeichens (USART I/O Data Register)
	return (0);
}

//############################################################################
// Initialisierung der seriellen Schnittstelle (USART)
void UART_Init (void)
//############################################################################
{
	UCR =	(1 << TXEN);						// enable USART transmitter
	UCR |=	(1 << RXEN);						// enable USART receiver
	UBRR =	(SYSCLK / (BAUD_RATE * 16L) - 1);	// Teiler setzen
	fdevopen (uart_putchar, NULL, 0);			// Ausgabekanal fr printf (STDOUT) ffnen
}

